MethodExpressionImpl (Apache Tomcat 11.0.24 API Documentation)
Description: declaration: package: org.apache.el, class: MethodExpressionImpl

# Class MethodExpressionImpl

java.lang.Object
jakarta.el.Expression
jakarta.el.MethodExpression
org.apache.el.MethodExpressionImpl

All Implemented Interfaces:
  `Externalizable, Serializable`

public final class MethodExpressionImpl extends MethodExpression implements Externalizable
An `Expression` that refers to a method on an object.

The `ExpressionFactory.createMethodExpression(ELContext, String, Class, Class[])` method can be used to parse an expression string and return a concrete instance of `MethodExpression` that encapsulates the parsed expression. The `FunctionMapper` is used at parse time, not evaluation time, so one is not needed to evaluate an expression using this class. However, the `ELContext` is needed at evaluation time.

The `getMethodInfo(ELContext)` and `invoke(ELContext, Object[])` methods will evaluate the expression each time they are called. The `ELResolver` in the `ELContext` is used to resolve the top-level variables and to determine the behavior of the `.` and `[]` operators. For any of the two methods, the `ELResolver.getValue(ELContext, Object, Object)` method is used to resolve all properties up to but excluding the last one. This provides the `base` object on which the method appears. If the `base` object is null, a `NullPointerException` must be thrown. At the last resolution, the final `property` is then coerced to a `String`, which provides the name of the method to be found. A method matching the name and expected parameters provided at parse time is found, and it is either queried or invoked (depending on the method called on this `MethodExpression`).

See the notes about comparison, serialization and immutability in the `Expression` javadocs.

See Also:
  - `ELResolver`
  - `Expression`
  - `ExpressionFactory`
  - `MethodExpression`
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MethodExpressionImpl()`
  Default constructor.
  `MethodExpressionImpl(String expr, org.apache.el.parser.Node node, FunctionMapper fnMapper, VariableMapper varMapper, Class<?> expectedType, Class<?>[] paramTypes)`
  Constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object obj)`
  Determines whether the specified object is equal to this `Expression`.
  `String`
  `getExpressionString()`
  Returns the original String used to create this `Expression`, unmodified.
  `MethodInfo`
  `getMethodInfo(ELContext context)`
  Evaluates the expression relative to the provided context, and returns information about the actual referenced method.
  `MethodReference`
  `getMethodReference(ELContext context)`
  Obtain the `MethodReference` for the method to which this method expression resolves.
  `int`
  `hashCode()`
  Returns the hash code for this `Expression`.
  `Object`
  `invoke(ELContext context, Object[] params)`
  Evaluates the expression relative to the provided context, invokes the method that was found using the supplied parameters, and returns the result of the method invocation.
  `boolean`
  `isLiteralText()`
  Returns whether this expression is a literal text expression, meaning it does not contain any variables, functions, or operators and evaluates to a constant value.
  `boolean`
  `isParametersProvided()`
  Returns whether the parameters for the method invocation are provided by the expression or by the container.
  `void`
  `readExternal(ObjectInput in)`
  `void`
  `writeExternal(ObjectOutput out)`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MethodExpressionImpl

    public MethodExpressionImpl()
    Default constructor.

  - ### MethodExpressionImpl

    public MethodExpressionImpl(String expr, org.apache.el.parser.Node node, FunctionMapper fnMapper, VariableMapper varMapper, Class<?> expectedType, Class<?>[] paramTypes)
    Constructor.
    Parameters:
      `expr` - the expression
      `node` - the node
      `fnMapper` - the function mapper
      `varMapper` - the variable mapper
      `expectedType` - the expected type
      `paramTypes` - the parameter types

- ## Method Details

  - ### equals

    public boolean equals(Object obj)
    Determines whether the specified object is equal to this `Expression`.

    The result is `true` if and only if the argument is not `null`, is an `Expression` object that is the of the same type (`ValueExpression` or `MethodExpression`), and has an identical parsed representation.

    Note that two expressions can be equal if their expression Strings are different. For example, `${fn1:foo()}` and `${fn2:foo()}` are equal if their corresponding `FunctionMapper`s mapped `fn1:foo` and `fn2:foo` to the same method.

    Specified by:
      `equals` in class `Expression`
    Parameters:
      `obj` - the `Object` to test for equality.
    Returns:
      `true` if `obj` equals this `Expression`; `false` otherwise.
    See Also:
      - `Hashtable`
      - `Object.equals(java.lang.Object)`

  - ### getExpressionString

    public String getExpressionString()
    Returns the original String used to create this `Expression`, unmodified.

    This is used for debugging purposes but also for the purposes of comparison (e.g. to ensure the expression in a configuration file has not changed).

    This method does not provide sufficient information to re-create an expression. Two different expressions can have exactly the same expression string but different function mappings. Serialization should be used to save and restore the state of an `Expression`.

    Specified by:
      `getExpressionString` in class `Expression`
    Returns:
      The original expression String.
    See Also:
      - `Expression.getExpressionString()`

  - ### getMethodInfo

    public MethodInfo getMethodInfo(ELContext context) throws PropertyNotFoundException, MethodNotFoundException, ELException
    Evaluates the expression relative to the provided context, and returns information about the actual referenced method.
    Specified by:
      `getMethodInfo` in class `MethodExpression`
    Parameters:
      `context` - The context of this evaluation
    Returns:
      an instance of `MethodInfo` containing information about the method the expression evaluated to.
    Throws:
      `NullPointerException` - if context is `null` or the base object is `null` on the last resolution.
      `PropertyNotFoundException` - if one of the property resolutions failed because a specified variable or property does not exist or is not readable.
      `MethodNotFoundException` - if no suitable method can be found.
      `ELException` - if an exception was thrown while performing property or variable resolution. The thrown exception must be included as the cause property of this exception, if available.
    See Also:
      - `MethodExpression.getMethodInfo(jakarta.el.ELContext)`

  - ### hashCode

    public int hashCode()
    Returns the hash code for this `Expression`.

    See the note in the `equals(Object)` method on how two expressions can be equal if their expression Strings are different. Recall that if two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result. Implementations must take special note and implement `hashCode` correctly.

    Specified by:
      `hashCode` in class `Expression`
    Returns:
      The hash code for this `Expression`.
    See Also:
      - `equals(Object)`
      - `Hashtable`
      - `Object.hashCode()`

  - ### invoke

    public Object invoke(ELContext context, Object[] params) throws PropertyNotFoundException, MethodNotFoundException, ELException
    Evaluates the expression relative to the provided context, invokes the method that was found using the supplied parameters, and returns the result of the method invocation.
    Specified by:
      `invoke` in class `MethodExpression`
    Parameters:
      `context` - The context of this evaluation.
      `params` - The parameters to pass to the method, or `null` if no parameters.
    Returns:
      the result of the method invocation (`null` if the method has a `void` return type).
    Throws:
      `NullPointerException` - if context is `null` or the base object is `null` on the last resolution.
      `PropertyNotFoundException` - if one of the property resolutions failed because a specified variable or property does not exist or is not readable.
      `MethodNotFoundException` - if no suitable method can be found.
      `ELException` - if an exception was thrown while performing property or variable resolution. The thrown exception must be included as the cause property of this exception, if available. If the exception thrown is an `InvocationTargetException`, extract its `cause` and pass it to the `ELException` constructor.
    See Also:
      - `MethodExpression.invoke(jakarta.el.ELContext, java.lang.Object[])`

  - ### readExternal

    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException
    Specified by:
      `readExternal` in interface `Externalizable`
    Throws:
      `IOException`
      `ClassNotFoundException`

  - ### writeExternal

    public void writeExternal(ObjectOutput out) throws IOException
    Specified by:
      `writeExternal` in interface `Externalizable`
    Throws:
      `IOException`

  - ### isLiteralText

    public boolean isLiteralText()
    Description copied from class: `jakarta.el.Expression`
    Returns whether this expression is a literal text expression, meaning it does not contain any variables, functions, or operators and evaluates to a constant value.
    Specified by:
      `isLiteralText` in class `Expression`
    Returns:
      `true` if this expression is a literal text, `false` otherwise

  - ### isParametersProvided

    public boolean isParametersProvided()
    Description copied from class: `jakarta.el.MethodExpression`
    Returns whether the parameters for the method invocation are provided by the expression or by the container.
    Overrides:
      `isParametersProvided` in class `MethodExpression`
    Returns:
      This default implementation always returns `false`

  - ### getMethodReference

    public MethodReference getMethodReference(ELContext context)
    Description copied from class: `jakarta.el.MethodExpression`
    Obtain the `MethodReference` for the method to which this method expression resolves.
    Overrides:
      `getMethodReference` in class `MethodExpression`
    Parameters:
      `context` - The EL context for this evaluation
    Returns:
      This default implementation always returns `null`